//---------------------------------------------------------------------------
//
//   DiffObject
//
//          Copyright(C) 2013, Tark
//
//     I2IuWFNg̈ʒüقȂ钸_I
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"
#include "CMQObject.h"
#include "DiffObject.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void DiffObject::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A186D;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *DiffObject::GetPlugInName(void)
{
	// vOC
	return "DiffObject ver.1.0 Copyright(C) 2013, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *DiffObject::EnumString(int index)
{
	switch(index){
	case 0: return "DiffObject"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static DiffObject plugin;
	return &plugin;
}

BOOL DiffObject::Execute(int index, MQDocument doc_)
{
	switch(index){
	case 0:
		{
			doc = cmq::CMQDocument(doc_);
			return main();
		}
	}
	return FALSE;
}

float DiffObject::diff = 0.001f;

DiffObject::DiffObject() : doc(nullptr)
{
}

DiffObject::~DiffObject()
{
}

BOOL DiffObject::main()
{
	int target[2];
	if(!getTargetObject(target)) {
		return FALSE;
	}

	return selectDifferent(target[0], target[1]);
}

BOOL DiffObject::getTargetObject(int target[])
{
	int ocount = doc.getObjectCount();
	int tcount = 0;
	for(int i = 0; i < ocount; i++) {
		cmq::CMQObject obj = doc.getObject(i);
		if(!obj || !obj.getSelected()) {
			continue;
		}
		target[tcount++] = i;
		if(tcount == 2) {
			break;
		}
	}
	if(tcount != 2) {
		return FALSE;
	}
	return TRUE;
}

BOOL DiffObject::selectDifferent(int o1, int o2)
{
	cmq::CMQObject obj1(doc.getObject(o1));
	cmq::CMQObject obj2(doc.getObject(o2));
	
	int vcount = min(obj1.getVertexCount(), obj2.getVertexCount());
	bool selected = false;
	for(int i = 0; i < vcount; i++) {
		if(obj1.getVertexRefCount(i) > 0 && doc.isSelectVertex(obj1, i)) {
			selected = true;
			break;
		}
		if(obj2.getVertexRefCount(i) > 0 && doc.isSelectVertex(obj2, i)) {
			selected = true;
			break;
		}
	}

	for(int i = 0; i < vcount; i++) {
		if(obj1.getVertexRefCount(i) == 0 || obj2.getVertexRefCount(i) == 0) {
			if(obj1.getVertexRefCount(i)) {
				doc.addSelectVertex(obj2, i);
			}
			else if(obj2.getVertexRefCount(i)) {
				doc.addSelectVertex(obj1, i);
			}
			continue;
		}
		if(selected && !doc.isSelectVertex(obj1, i) && !doc.isSelectVertex(obj2, i)) {
			doc.deleteSelectVertex(obj1, i);
			doc.deleteSelectVertex(obj2, i);
			continue;
		}
		MQPoint p1 = obj1.getVertex(i);
		MQPoint p2 = obj2.getVertex(i);
		if((p1 - p2).norm() > diff) {
			doc.addSelectVertex(obj1, i);
			doc.addSelectVertex(obj2, i);
		}
		else {
			doc.deleteSelectVertex(obj1, i);
			doc.deleteSelectVertex(obj2, i);
		}
	}
	for(int i = vcount; i < obj1.getVertexCount(); i++) {
		if(obj1.getVertexRefCount(i) > 0) {
			doc.addSelectVertex(obj1, i);
		}
	}
	for(int i = vcount; i < obj2.getVertexCount(); i++) {
		if(obj2.getVertexRefCount(i) > 0) {
			doc.addSelectVertex(obj2, i);
		}
	}
	return TRUE;
}
